#!perl -w
# this script runs part of the slow test suite
# if should be called with an argument that gives the run number
# this runs the models in the following load-leveled list of sims
# 0 will do from the 0th to 1st in the list
# if no number is given then 0th run is done

# this vector gives the load-leveled list of model numbers
# zero runs first, then < second
@runs=(0,5,11,1000);

# this is the number of different runs that are possible with the above array
# due to counting from zero, we are called with argv of 0, 1, and 2 for now
# so two is the limit
# this gets the size of the array at subtracts two
$LAST = @runs - 2;

if(!$ARGV[0]) 
{
   $ARGV[0] = 0;;
}
# this gives which one of the set this is
$nrun = $ARGV[0];

# these are the runs we shall do
#$runs[0]=0;
#$runs[1]=4;
#$runs[2]=9;
#$runs[3]=1000;

# the disk drive 
$c = "M";

# try using net use net use u: \\server-name\share-name\
system( "net use $c: \\\\nimbus\\nimbus_c\$ /persistent:no" );

$in_dir = "$c:/projects/cloudy/trunk/tsuite/slow/";
$out_dir = "$c:/projects/cloudy/trunk/tsuite/slow/";

# move to the output directory
chdir( $out_dir or die "could not move to test suite directory\n");

$log_file = "dayslow"."$nrun".".log";
open( ioLOG , ">$log_file" );
printf( ioLOG "have moved to output dir and opened log files\n");
printf( ioLOG "input dir is $in_dir, out is $out_dir\n");

if( $nrun == 0 || $nrun == 1 || $nrun == 2 )
{
   printf( ioLOG " start run number $nrun for test suite\n");
}
else
{
   printf( ioLOG " invalid run number $nrun for test suite\n");
   exit(1);
}

# next two give first and last sim to compute in the range that are present
# if( $nModTotal >= $nSkip && $nModTotal < $nmod_calc )
# first sim to actually compute
$nSkip = $runs[$nrun];
# this is the upper bound
$nmod_calc = $runs[$nrun+1];

#$exe = "$c:/projects/Cloudy/current_net/Debug/current_net.exe";
#$exe = "$c:\\projects\\Cloudy\\trunk\\current_net\\Debug\\current_net.exe";
$exe_org = "$c:/projects/cloudy/trunk/release/current.exe";
system("cp $exe_org $out_dir ");
#$exe = "c:/projects/Cloudy/trunk/release/current.exe";
$exe = "$out_dir"."current.exe";
printf(ioLOG "exe is $exe\n");

$TRUE = 1;
$FALSE = 0;

# if true then always recompute even when exe is older than results
$lgForceCompute = $TRUE;
# if false then only recompute when newer exe than results
$lgForceCompute = $FALSE;

# file containing any errors, also used for timestamp
$errors = "$out_dir"."errors"."$nrun".".txt";
# this file exists while long checking runs with purify are in pregress
$blockrun = "blockfile.txt";
# file with list of PROBLEM and DEBUG strings
$problem_file = "$out_dir"."problems"."$nrun".".txt";

# does $exe exist?
if( !open(EXEFILE, "$exe_org") ) 
{
	printf( ioLOG "executable did not exist so exiting without running.\n" );
	printf( STDERR "executable did not exist so exiting without running.\n" );
	exit(1);
}

# see if errors.txt exists, if it does, and younger than exe file, just quit
# $lgForceCompute set above, option to force recomputing model
if( !$lgForceCompute  )
{
	if( -e $errors )
	{
		# is age of errors file smaler than exe file?
		if( (-M $errors) < (-M EXEFILE ) )
		{
			printf( ioLOG "executable older than errors.txt so exit.\n" );
			# no need to run tests, just quit
			exit(2);
		}
		# this file created when purify test is running 
		if( -e $blockrun )
		{
			printf( ioLOG "blockrun file exists so exit.\n" );
			# no need to run tests, just quit
			exit(3);
		}
	}
}


printf( ioLOG "entering loop, exe is $exe \n" );

# counter for total number of sims in directory
$nModTotal = 0;
# counter for number we actually computed
$nComputed = 0;

while( defined( $input = glob("$in_dir*.in") ) )
{
	if( $nModTotal >= $nSkip && $nModTotal < $nmod_calc )
	{
		# copy input file to fileout to exit it
		$output = $input;
		$output =~ s/$in_dir/$out_dir/gi;
		# change .in to .out
		$output =~ s/\.in/.out/gi;
                # create backup file if output exists already
                if( -e $output )
                {
		   $backup = $output;
                   $backup =~ s/\.out/\.bak/gi;
                   system( "cp $output $backup " );
                }
		# $output = "$out_dir"."$output";
		system "nice -n 5 $exe < $input  > $output ";
		printf( ioLOG "$input going to $output \n" );
		++$nComputed;
	}
	++$nModTotal;
}

printf( ioLOG "$nComputed sims were run\n");
# look for errors 
check_output();

# send mail announcing results,
# if no problem occur then also execute last_good.pl, copying files to last_good directory
send_mail();

#if this is the last run of the group, check for errors
if( $nrun == $LAST )
{
   # look for errors 
   system( "perl checkall.pl" );
   # does errors exist and have non-zero size?
   if( -s "serious.txt" )
   {
      # this branck - problems
      system("c:\\u\\blat\\blat.exe serious.txt -t gary\@pa.uky.edu -s \"last Cloudy slow run completed and errors existed\" " );
   }
   else
   {
      $script_dir = "$c:/projects/cloudy/trunk/scripts/";
      system( "perl \"$script_dir\"promote_last_good_slow.pl" );

      open( ioEMAIL , ">message.txt" );
      printf( ioEMAIL " Last Cloudy slow run completed and no errors found\n");  
      close( ioEMAIL );
      system("c:\\u\\blat\\blat.exe message.txt -t gary\@pa.uky.edu -s \"last Cloudy slow run finished and all are successfull\" " );
   }
}

exit(0);


#=============================================================
#             send_mail(),
#=============================================================

sub send_mail 
{


	# does errors exist and have non-zero size?
	if( -s "$errors" )
	{
                system("c:\\u\\blat\\blat.exe $errors -t gary\@pa.uky.edu -s \"Cloudy slow run dayslow$nrun had errors\" " );
	}
	else
	{
                 open( ioEMAIL , ">message.txt" );
      
                 printf( ioEMAIL " Cloudy slow run dayslow$nrun ran OK on PC\n");  
                 printf( ioEMAIL " no crashes or asserts\r\n" ) ;
                 close( ioEMAIL );
                system("c:\\u\\blat\\blat.exe message.txt -t gary\@pa.uky.edu -s \"Cloudy slow run dayslow$nrun successfull\" " );

	}

        # now check for problems that occurred
        if( -s "$problem_file" )
        {
                system("c:\\u\\blat\\blat.exe problems.txt -t gary\@pa.uky.edu -s \"Cloudy slow run dayslow$nrun PROBLEM or DEBUG string\" " );
        }
 }


#===========================================================
#          check_output()
#===========================================================
sub check_output 
{

	#find "BOTCH " and "W-" string in all the output file and write
	#corresponding line into messages file.
	if( $lgLOGGING )
	{
		printf( ioLOG "check_output entered\n");
	}

	# check  output file to see whether they contain "Cloudy ends:"
	# string and write corresponding line into checkend.txt file.
	# if size of file $out_dir/checkend.txt is zero, then program crashed.  

	$checkend = "$out_dir"."checkend.txt";
        # search for PROBLEM in any file
        if( -e $problem_file )
        {
           unlink( $problem_file );
        }
        if( -e $errors )
        {
           unlink( $errors );
        }

        # counter for total number of sims in directory
        $nModTotal = 0;
        while( defined( $input = glob("$in_dir*.in") ) )
        {
           if( $nModTotal >= $nSkip && $nModTotal < $nmod_calc )
           {
	      # form name of output file
	      # change input dir name to output
              $output = $input;
              $output =~ s/$in_dir/$out_dir/gi;
              # change .in to .out
              $output =~ s/\.in/.out/gi;

	      system "grep -H Botch  $output >>$errors";
	      system "grep -H \"W-\"  $output >> $errors";
	      # check whether it crashed
	      system "grep -H \"ChkAssert\"  $output > $checkend ";
	      # check whether output file exists and has zero size (string did not occur)
	      if(-z "$checkend")
	      {
		 system( "echo \"$output did not end or had no asserts\" >> $errors " );      
	      }
	      # find all PROBLEMs 
	      system( "grep -H \"PROBLEM\"  $output > $problem_file" );
	      # now look for debug print strings and cat to end
	      system( "grep -H \"DEBUG\"  $output >> $problem_file" );
           }
           ++$nModTotal;
	}

         # check whether any models were skipped because they were renamed *.skip
         system "ls \"$out_dir*.skip\" > skip.txt" ;
         # skipfile will have non-zero length if *.skip returned any names
         if( -s "skip.txt" )
         {
            print STDERR "\n\n some files were skipped by renmaing to .skip - list is in skip.txt\n" ;
            system "echo some files were skipped by renmaing to .skip - list is in skip.txt >> checkall.txt ";
         }

	if( $lgLOGGING )
	{
		printf( ioLOG "check_output exits\n");
	}

}

